'Verzija 1:  z eno tipko vklopimo z drugo izklopimo 1 rele

$regfile = "89c2051.dat"
$crystal = 12000000
$baud = 2400

Dim Relevklop As Bit , Reledol As Bit


P1.2 = Relevklop
P3.7 = Reledol

Relevklop = 0
Reledol = 0


Dim Xx1 As Byte                 'input area
Dim Xx2 As Byte                 'buffer area
Dim Xx3 As Byte                 'output and process area
Dim Msg As Bit
Dim Ab As Bit                   'pomozna spr.
Dim Cd As Bit                   'pomozna spr.
Ab = 0                          'zac. stanje: rele je izkl.
Cd = 0

Print ;
Enable Serial
On Serial Serrut
Reset Msg
'
' e Je Frekvenca Krislata F Je Timerenota 12 / F
' Do prekinitve pride po
'      1 timerenot   krat vrednost load pri mode je  2
'     32 timerenot   krat vrednost load pri mode je  0
'    256 timerenot   krat vrednost load pri mode je  1
'
Config Timer0 = Timer , Gate = Internal , Mode = 0
On Timer0 Timer0isr
Load Timer0 , 100               '100 * 32 usec = 3200usec
Enable Timer0
Start Timer0
Priority Set Serial
Enable Interrupts

Dim Tistevec As Word
' Ti stevec je del krmilnega mehanizma.
' Tistevec timer0 prekinitvni podprogram porine navzgor vsake 3 msec
'      a najve do Timax
' Kadar je dvigalo poenemo, dami tistevec na 0 in vsakokrat ko pride
'      nov ukaz v isto smer, tudi. e novega ukaza v isto smer ni dovolj kmalu
'      se dvigalo ustavi, ko pride tistevec do vrednosti tistop
' Kadar se dvigalo ustavi, postavimo stevec na timax.
' Kadar dvigalo stoji in prihajajo novi ukazi za pogon dvigala, zmanjsamo
'      tistevec za tikorak, toda dvigalo poenemo ele. ko tistevec pride
'      pod vrednost tistart. Takrat ele dvigalo poenemo.
'
Const Nula = 0
Const Tistop = 8
Const Ticakaj = 100             '1000 * 3.2 msec = 3 sek
Const Tispet = Tistop + Ticakaj
Const Tistart = 30
Const Timax = 250
Const Tikorak = 10
Tistevec = Timax

Dim Smer As Byte
Const Gor = &HFA
Const Dol = &HF5
Const Stoj = &HF0
Smer = Stoj

'
Do
  If Msg = 1 Then
    Xx3 = Xx2
      If Smer = Xx3 And Smer <> Stoj Then
      '  ali sprejeti bajt potrjuje obstojeo smer gibanja?
         Tistevec = 0
      End If
      If Smer = Stoj Then
         If Xx3 = Gor Or Xx3 = Dol Then
      '  ali dvigalo miruje in je bajt veljaven?
            If Tistevec > Tistart Then
               Tistevec = Tistevec - Tikorak
            End If
         End If
      End If
    Reset Msg
  End If

  ' V kolikor smo v dovolj kratkem asu dobili v zaporedju dovolj
  '        enakih bajtov veljavnega ukaza
  ' in dvigalo miruje, tedaj dvigalo poenemo:
  If Smer = Stoj And Tistevec <= Tistart Then
     If Xx3 = Gor Or Xx3 = Dol Then
        Smer = Xx3
        Tistevec = 0
     End If
  End If

  ' V kolikor je tistevec preko tistopa, zaustavimo dvigalo:
  If Tistevec > Tistop And Smer <> Stoj Then
     'Smer = Stoj
     'Reset Relevklop
     'Reset Reledol
     Do
     'akaj gotov as v zanki potem, ko zaustavimo dvigalo
     Loop Until Tistevec > Tispet
     Tistevec = Timax
  End If

  ' upravljamo releja na osnovi vsebine bajta smer
  If Smer = Stoj Then
     'Ab = Not Ab
     'Cd = Not Cd
     'Reset Relevklop
     'Reset Reledol
  End If

  If Smer = Gor Then
      Relevklop = 0
      P3.7 = Relevklop
      Waitms 200
      Waitms 200
      Smer = Stoj
  End If

  If Smer = Dol Then
      Relevklop = 1
      P3.7 = Relevklop
      Waitms 200
      Waitms 200
      Smer = Stoj
  End If



Loop


' ////////////////////////////////////////////////////////////
Serrut:
Xx1 = Inkey()
Scon.1 = 0
Xx2 = Xx1
If Xx2 = Gor Or Xx2 = Dol Then
  Set Msg
End If
Return

' ////////////////////////////////////////////////////////////
Timer0isr:
   Load Timer0 , 100
   If Tistevec < Timax Then
     Incr Tistevec
   End If
Return